#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false) ;
    cin.tie(0) ;
    long long n ,k ;
    cin >> n >>  k ;
    int d[k] ;
    int ds[k] ;
    for(int i=0 ; i<k ; i++){
        cin >> d[i] ;
        ds[i]=d[i] ;
    }
    sort(ds,ds+k) ;
    for(int i=0 ; i<k ; i++){
        int ind=lower_bound(ds,ds+k,d[i])-ds ;
        int r=1 ;
        for(int j=1 ; j<=ind ; j++){
            if(d[i]%ds[j]==0){
                r=r^ds[j] ;
            }
        }
        cout << r << "\n" ;
    }
    return 0;
}